<?php

namespace Drupal\Tests\yasm_blocks\Functional;

use Drupal\Tests\BrowserTestBase;

/**
 * Provides a class for Yasm charts functional tests.
 *
 * @group yasm
 */
class YasmBlocksTest extends BrowserTestBase {

  /**
   * {@inheritdoc}
   */
  public static $modules = ['yasm_blocks'];

  /**
   * {@inheritdoc}
   */
  protected $defaultTheme = 'stable';

  /**
   * Admin users with all permissions.
   *
   * @var \Drupal\user\UserInterface
   */
  protected $yasmUser;

  /**
   * {@inheritdoc}
   */
  protected function setUp() {
    parent::setUp();

    // Create yasm user.
    $this->yasmUser = $this->drupalCreateUser([
      'view the administration theme',
      'access administration pages',
      'administer blocks',
    ]);
  }

  /**
   * Tests users access.
   */
  public function testsYasmBlocks() {
    $this->drupalLogin($this->yasmUser);

    $this->drupalGet('admin/structure/block/library/stable');
    $this->assertSession()->statusCodeEquals(200);
    $this->assertSession()->responseContains('YASM site counts');
    $this->assertSession()->responseContains('YASM current user counts');

    $theme = \Drupal::service('theme_handler')->getDefault();
    $this->drupalGet("admin/structure/block/add/yasm_block_user/$theme");
    $this->assertSession()->statusCodeEquals(200);

    $this->drupalGet("admin/structure/block/add/yasm_block_site/$theme");
    $this->assertSession()->statusCodeEquals(200);
  }

}
